<?php

namespace Drupal\entity_theme_engine\Normalizer;


class EntityReferenceItemNormalizer extends FieldItemNormalizer {

  /**
   * The interface or class that this Normalizer supports.
   *
   * @var string
   */
  protected $supportedInterfaceOrClass = ['Drupal\Core\Field\Plugin\Field\FieldType\EntityReferenceItem'];

  /**
   * {@inheritdoc}
   */
  public function normalize($field, $format = NULL, array $context = []) {
    try {
      $data = [
        'label' => $field->entity->label(),
        'url' => $field->entity->toUrl()->toString(),
        'render' => $this->entityTypeManager->getViewBuilder($field->entity->getEntityTypeId())->view($field->entity),
      ];
    } catch (\Exception $e) {
      $data = parent::normalize($field, $format, $context);
    }
    return $data;
  }

}
