<?php

namespace Drupal\entity_theme_engine\Normalizer;


class ImageItemNormalizer extends FieldItemNormalizer {

  /**
   * The interface or class that this Normalizer supports.
   *
   * @var string
   */
  protected $supportedInterfaceOrClass = ['Drupal\image\Plugin\Field\FieldType\ImageItem'];

  /**
   * {@inheritdoc}
   */
  public function normalize($field, $format = NULL, array $context = []) {
    $data = parent::normalize($field, $format, $context);
    $data['styles'] = [];
    $styles = $this->getStyles();
    foreach ($styles as $id => $style) {
      $data['styles'][$id] = $style->buildUrl($field->entity->getFileUri());
    }
    return $data;
  }
  
  protected function getStyles() {
    $cache = &drupal_static(__METHOD__, []);
    if(empty($cache)) {
      $cache = $this->entityTypeManager->getStorage('image_style')->loadMultiple();
    }
    return $cache;
  }

}
